<?php
/*
Plugin Name: XHTML Video Embed
Plugin URI: http://saltwaterc.net/xhtml-video-embed
Description: WordPress plugin which embeds the videos in the right way, the XHTML way. The plugin is self documented, so please check <a href="options-general.php?page=xhtml-video-embed.php">Options &raquo; XVE Options</a> for configuration details and usage information.
Version: 0.2.1
Author: SaltwaterC
Author URI: http://saltwaterc.net/
License: GPL v2.0
*/

function swc_flash_object($_fileType)
	{
	switch ($_fileType)
		{
		default:
		$_objH=386;
		break;
		
		case "audio":
		$_objH=46;
		break;
		}
	$_displayCredit=(get_option("swc_display_credit")=="no")?"<!-- Valid XHTML ".$_fileType." object delivered by XHTML Video Embed. Get it at: http://saltwaterc.net/xhtml-video-embed -->":"<small><a href='http://saltwaterc.net/xhtml-video-embed' target='_blank'>&raquo; Powered by XHTML Video Embed</a></small>";
	$_flashObject=<<<FLASH

<object type="application/x-shockwave-flash" style="width: 448px; height: {$_objH}px;" data="&*DATA*&">
<param name="movie" value="&*DATA*&" />
<param name="wmode" value="transparent" />
<param name="pluginspage" value="http://www.macromedia.com/go/getflashplayer" />
</object>
<br/>
{$_displayCredit}
FLASH;
	return $_flashObject;
	}
	
function swc_convert_url($_iURL, $_fileType, $_supportedService)
	{
	switch ($_supportedService)
		{
		case "swf":
		return $_iURL;
		break;
		
		case "youtube":
		preg_match("@v=(.*)@i", $_iURL, $_theMatch);
		$_theMatch=preg_replace("@&.*@i", "", $_theMatch[1]);
		return "http://www.youtube.com/v/".$_theMatch;
		break;
		
		case "google-video":
		preg_match("@docid=(.*)@i", $_iURL, $_theMatch);
		$_theMatch=preg_replace("@&.*@i", "", $_theMatch[1]);
		return "http://video.google.com/googleplayer.swf?docId=".$_theMatch."&amp;hl=en";
		break;
		
		case "metacafe":
		$_smallPieces=explode("/", $_iURL);
		return "http://www.metacafe.com/fplayer/".$_smallPieces[4]."/".$_smallPieces[5].".swf";
		break;
		
		case "trilu-video":
		$_smallPieces=explode("/", $_iURL);
		return "http://www.trilulilu.ro/flash/e".$_fileType."player.swf?hash=".$_smallPieces[4]."&amp;userid=".$_smallPieces[3];
		break;
		
		case "trilu-audio":
		$_smallPieces=explode("/", $_iURL);
		return "http://www.trilulilu.ro/flash/e".$_fileType."player.swf?hash=".$_smallPieces[4]."&amp;userid=".$_smallPieces[3];
		break;
		
		case "trilu-imagine":
		$_smallPieces=explode("/", $_iURL);
		return "http://www.trilulilu.ro/flash/e".$_fileType."player.swf?hash=".$_smallPieces[4]."&amp;userid=".$_smallPieces[3];
		break;
		
		default:
		return "CODING ERROR!!!";
		break;
		}
	}

function swc_content_filter($_theContent='', $_fileType, $_supportedService)
	{
	$n=preg_match_all("@\[".$_supportedService."\](.*)\[/".$_supportedService."\]@i", $_theContent, $_theMatches);
	$i=0;
	while ($i<$n)
		{
		$_theContent=str_replace($_theMatches[0][$i], str_replace("&*DATA*&", swc_convert_url($_theMatches[1][$i], $_fileType, $_supportedService), swc_flash_object($_fileType)), $_theContent);
		$i++;
		}
	return $_theContent;
	}

function swc_xhtml_video_embed($_theContent='')
	{
	// Making sure that the default options are defined
	swc_add_options();
	//The call to the functuion which does all the conversion should be something like: $_theContent=swc_content_filter($_theContent, $_fileType, $_supportedService); - where the $_fileType is video, audio or image, and $_supported service must be defined into the swc_convert_url()'s switch
	
	// Generic SWF support:
	if (get_option("swc_swf_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "video", "swf");
	// YouTube support:
	if (get_option("swc_youtube_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "video", "youtube");
	// Google Video support:
	if (get_option("swc_google_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "video", "google-video");
	// Metacafe support:
	if (get_option("swc_metacafe_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "video", "metacafe");
	// Trilulilu Video support:
	if (get_option("swc_trilu_video_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "video", "trilu-video");
	// Trilulilu Audio support:
	if (get_option("swc_trilu_audio_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "audio", "trilu-audio");
	// Trilulilu Image support:
	if (get_option("swc_trilu_image_support")=="yes")
		$_theContent=swc_content_filter($_theContent, "image", "trilu-imagine");
	
	return $_theContent;
	}
	
function swc_xhtml_video_admin()
	{
	if (function_exists('add_options_page'))
		{
		add_options_page('xhtml-video-embed', 'XVE Options', 1, basename(__FILE__), 'swc_xhtml_video_admin_panel');
		}
	}
	
function swc_add_options()
	{
	// Add some options at the first usage:
	// Service support:
	add_option("swc_swf_support", "yes");
	add_option("swc_trilu_video_support", "yes");
	add_option("swc_trilu_audio_support", "yes");
	add_option("swc_trilu_image_support", "yes");
	add_option("swc_metacafe_support", "yes");
	add_option("swc_google_support", "yes");
	add_option("swc_youtube_support", "yes");
	// Plugin options:
	add_option("swc_display_credit", "no");
	}
	
function swc_xhtml_video_admin_panel()
	{
	swc_add_options();
	
	if ($_SERVER['REQUEST_METHOD']=="POST")
		{
		if (isset($_POST['xve_update']))
			{
			$option=($_POST['use_swf']=="on")?"yes":"no";
			update_option('swc_swf_support', $option);
			
			$option=($_POST['use_youtube']=="on")?"yes":"no";
			update_option('swc_youtube_support', $option);
			
			$option=($_POST['use_google']=="on")?"yes":"no";
			update_option('swc_google_support', $option);
			
			$option=($_POST['use_metacafe']=="on")?"yes":"no";
			update_option('swc_metacafe_support', $option);
			
			$option=($_POST['use_trilu_video']=="on")?"yes":"no";
			update_option('swc_trilu_video_support', $option);
			
			$option=($_POST['use_trilu_audio']=="on")?"yes":"no";
			update_option('swc_trilu_audio_support', $option);
			
			$option=($_POST['use_trilu_image']=="on")?"yes":"no";
			update_option('swc_trilu_image_support', $option);
			
			$option=($_POST['use_credit']=="on")?"yes":"no";
			update_option('swc_display_credit', $option);
			}
		}
		
	echo '
	<div class="wrap">
	<h2>XHTML Video Embed Options</h2>
	<form method="post" action="'.$_SERVER['PHP_SELF']."?".$_SERVER['argv'][0].'">
	<table width="100%">
	<tr>
		<td colspan="3" align="right"><p class="submit"><input type="submit" name="xve_update" value="Update Options &raquo;" /></p></td>
	</tr>
	<tr>
		<td colspan="3"><h3>Video services options:</h3></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use generic SWF support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_swf" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_swf_support"));
	echo ' /></td>
		<td>Usage: <strong>[swf]path-to-swf-file[/swf]</strong><br />Note: the path can be either relative, or absolute. The absolute path is recommended if you use the pretty permalink structure when loading files which are hosted by you. By using absolute paths, you can avoid certain disfunctionalities. Of course, an absolute path is required if you use a SWF object hosted onto another domain.<br /><br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use YouTube support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_youtube" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_youtube_support"));
	echo ' /></td>
		<td>Usage: <strong>[youtube]http://www.youtube.com/watch?v=5LtYk7wsFnk[/youtube]</strong><br />Note: The extra parameters are ignored if you use a permalink like - http://www.youtube.com/watch?v=5LtYk7wsFnk<em>&amp;feature=dir</em><br /><br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use Google Video support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_google" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_google_support"));
	echo ' /></td>
		<td>Usage: <strong>[google-video]http://video.google.com/videoplay?docid=-1770384172897733802[/google-video]</strong><br />Note: The extra parameters are ignored if you use a permalink like - http://video.google.com/videoplay?docid=-1770384172897733802<em>&amp;extra_parameter=extra_value</em><br /><br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use Metacafe support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_metacafe" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_metacafe_support"));
	echo ' /></td>
		<td>Usage: <strong>[metacafe]http://www.metacafe.com/watch/822298/too_much_time_to_waste/[/metacafe]</strong><br /><br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use Trilulilu Video support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_trilu_video" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_trilu_video_support"));
	echo ' /></td>
		<td>Usage: <strong>[trilu-video]http://www.trilulilu.ro/SaltwaterC/54fcf02ed330bd[/trilu-video]</strong><br /><br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use Trilulilu Audio support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_trilu_audio" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_trilu_audio_support"));
	echo ' /></td>
		<td>Usage: <strong>[trilu-audio]http://www.trilulilu.ro/ambro/26129477a2da0c[/trilu-audio]</strong><br /><br /></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use Trilulilu Image support?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_trilu_image" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_trilu_image_support"));
	echo ' /></td>
		<td>Usage: <strong>[trilu-imagine]http://www.trilulilu.ro/SaltwaterC/336f07c30b8849[/trilu-imagine]</strong><br /><br /></td>
	</tr>
	<tr>
		<td colspan="3"><h3>Miscellaneous options:</h3></td>
	</tr>
	<tr>
		<td align="right" valign="top" width="20%">Use credit for XVE?</td>
		<td align="center" valign="top"><input type="checkbox" name="use_credit" class="tog" style="margin-left: +10px; margin-right: +10px;"';
	echo checked('yes', get_option("swc_display_credit"));
	echo ' /></td>
		<td>Note: this places a small URL under the inserted flash object with <a href="http://saltwaterc.net/xhtml-video-embed" target="_blank">&raquo; Powered by XHTML Video Embed</a>. You don\'t have to use it, so that\'s why it\'s disabled by default. If you would like to support the spreading of this plugin (and me as developer), then please check this option. Otherwize, the plugin displays it in silent mode (as XHTML comment). If you mind using this, then remove it from the source code.<br /><br /></td>
	</tr>
	<tr>
		<td colspan="3" align="right"><p class="submit"><input type="submit" name="xve_update" value="Update Options &raquo;" /></p></td>
	</tr>
	</table>
	</form>
	<p>Plugin developed by <a href="http://saltwaterc.net/" target="_blank">SaltwaterC</a> under the <a href="http://www.gnu.org/licenses/old-licenses/gpl-2.0.html" target="_blank">GPL v2.0</a> license.</p>
	</div>';
	}

// Adding the hooks:
add_filter('the_content', 'swc_xhtml_video_embed');
add_action('admin_menu', 'swc_xhtml_video_admin');
?>
